package com.javacodegeeks.example;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;

public class HibernateConfigTest {
	private static SessionFactory factory;
	private static ServiceRegistry serviceRegistry;

	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Configuration config = new Configuration();
		config.configure();
		config.addAnnotatedClass(Employee.class);
		config.addResource("Employee.hbm.xml");
		serviceRegistry = new StandardServiceRegistryBuilder().applySettings(config.getProperties()).build();
		factory = config.buildSessionFactory(serviceRegistry);
		
		HibernateConfigTest hbConfigTest = new HibernateConfigTest();
		hbConfigTest.addEmployee(7,"Mack","Johnson",5000);
		
		List<Employee> emps = hbConfigTest.getAllEmployees();
		for(Employee emp : emps){
			System.out.print(emp.getId() + " ");
			System.out.print(emp.getFirst_name() + " ");
			System.out.print(emp.getLast_name() + " ");
			System.out.println();
		}
	}
	
	private int addEmployee(int empId,String firstname, String lastname, int deptId)
	{
		Session session = factory.openSession();
		Transaction tx = null;
		Integer empIdSaved = null;
		try {
			tx = session.beginTransaction();
			Employee emp = new Employee(empId,firstname,lastname,deptId);
			empIdSaved = (Integer) session.save(emp);
			tx.commit();
		} catch(HibernateException ex) {
			if(tx != null)
				tx.rollback();
			ex.printStackTrace();
		} finally {
			session.close();
		}
		
		return empIdSaved;
	}
	
	private List getAllEmployees()
	{
		Session sesn = factory.openSession();
		Transaction tx = null;
		List employees = new ArrayList();
		try{
			tx = sesn.beginTransaction();
			employees = (List)sesn.createQuery("From Employee").list();
			tx.commit();
		} catch(HibernateException e) {
			e.printStackTrace();
		} finally {
			sesn.close();
		}
		
		return employees;
		
	}


}
